--
-- henly 20 (Ls_uk Modteam)
-- 10.12.2010
--
-- > www.LS-UK.info

Articulacao = {};

function Articulacao.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations) and SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Articulacao:load(savegame)

    self.Articulacaoautomatica = SpecializationUtil.callSpecializationsFunction("Articulacaoautomatica");
    self.Velocidaderotacao = 0;
    self.direcaobloqueada = true;    
   
    self.controlpath = Utils.getFilename("textures/at1.dds", self.baseDirectory);
    self.button1PoxX = 0.850;
    self.button1PoxY = 0.170;
    self.button1Width = 0.10;
    self.button1Height = 0.15;
    self.button1Overlay = Overlay:new("button1", self.controlpath, self.button1PoxX, self.button1PoxY, self.button1Width, self.button1Height);
    self.button1Active = true

    self.controlpath = Utils.getFilename("textures/at2.dds", self.baseDirectory);
    self.button2Overlay = Overlay:new("button2", self.controlpath, self.button1PoxX, self.button1PoxY, self.button1Width, self.button1Height);
    self.button2Active = true;
    
end;

function Articulacao:delete()
end;

function Articulacao:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    local direcaobloqueada = getXMLBool(xmlFile, key.."#autoSteer");
    if direcaobloqueada ~= nil then
        self:Articulacaoautomatica(direcaobloqueada);
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function Articulacao:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'autoSteer="'..tostring(self.direcaobloqueada)..'"';
    return attributes, nil;
end;
  
function Articulacao:readStream(streamId, connection)
    local lockedsteer = streamReadBool(streamId);
    self:Articulacaoautomatica(lockedsteer, true);
end;

function Articulacao:writeStream(streamId, connection)
      streamWriteBool(streamId, self.direcaobloqueada);
end;

function Articulacao:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Articulacao:keyEvent(unicode, sym, modifier, isDown)
end;

function Articulacao:update(dt)

    if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.Articulacao) then
            self:Articulacaoautomatica(not self.direcaobloqueada);
        end;
    end;
end;

function Articulacao:updateTick(dt)

    if self.direcaobloqueada then
        self.autoRotateBackSpeed = 2.5;
        self.Velocidaderotacao = 2*0.001;
    else
        self.autoRotateBackSpeed = 0;
        self.Velocidaderotacao = 0;
    end;
end;

function Articulacao:draw()

    if self:getIsActive() then
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Articulacao"), self.typeDesc), InputBinding.Articulacao);
        if self.direcaobloqueada then
            if self.button2Overlay ~= nil then
                if self.button2Active then
                    self.button2Overlay:render();
                end;
            end;
        else
            if self.button1Overlay ~= nil then
                if self.button1Active then
                    self.button1Overlay:render();
                end;
            end;
        end;
    end;
end;


function Articulacao:onEnter()
end;

function Articulacao:onLeave()
end;

function Articulacao:Articulacaoautomatica(lockedsteer, noEventSend)
    SetAutoSteerEvent.sendEvent(self, lockedsteer, noEventSend)
    self.direcaobloqueada = lockedsteer;
end;

SetAutoSteerEvent = {};
SetAutoSteerEvent_mt = Class(SetAutoSteerEvent, Event);
  
InitEventClass(SetAutoSteerEvent, "SetAutoSteerEvent");
  
function SetAutoSteerEvent:emptyNew()
    local self = Event:new(SetAutoSteerEvent_mt);
    self.className="SetAutoSteerEvent";
    return self;
end;
  
function SetAutoSteerEvent:new(object, lockedsteer)
    local self = SetAutoSteerEvent:emptyNew()
    self.object = object;
    self.lockedsteer = lockedsteer;
    return self;
end;
  
function SetAutoSteerEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.lockedsteer = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;
  
function SetAutoSteerEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
    streamWriteBool(streamId, self.lockedsteer);
end;
  
function SetAutoSteerEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    self.object:Articulacaoautomatica(self.lockedsteer, true);
end;
  
function SetAutoSteerEvent.sendEvent(vehicle, lockedsteer, noEventSend)
    if lockedsteer ~= vehicle.direcaobloqueada then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(SetAutoSteerEvent:new(vehicle, lockedsteer), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(SetAutoSteerEvent:new(vehicle, lockedsteer));
            end;
        end;
    end;
end;